diff --git a/tests/unit/modules/test_virt.py b/tests/unit/modules/test_virt.py
index 3e9bd5ef49..d3988464f6 100644
--- a/tests/unit/modules/test_virt.py
+++ b/tests/unit/modules/test_virt.py
@@ -1,865 +1,1238 @@
 # -*- coding: utf-8 -*-
-'''
+"""
 virt execution module unit tests
-'''
+"""
 
 # pylint: disable=3rd-party-module-not-gated
 
 # Import python libs
 from __future__ import absolute_import, print_function, unicode_literals
-import os
-import re
+
 import datetime
+import os
 import shutil
+import tempfile
 
-# Import Salt Testing libs
-from tests.support.mixins import LoaderModuleMockMixin
-from tests.support.unit import TestCase
-from tests.support.mock import MagicMock, patch
+import salt.config
+import salt.modules.config as config
+import salt.modules.virt as virt
+import salt.syspaths
 
 # Import salt libs
 import salt.utils.yaml
-import salt.modules.virt as virt
-import salt.modules.config as config
 from salt._compat import ElementTree as ET
-import salt.config
-import salt.syspaths
-import tempfile
-from salt.exceptions import CommandExecutionError
+from salt.exceptions import CommandExecutionError, SaltInvocationError
 
 # Import third party libs
 from salt.ext import six
+
 # pylint: disable=import-error
 from salt.ext.six.moves import range  # pylint: disable=redefined-builtin
 
+# Import Salt Testing libs
+from tests.support.mixins import LoaderModuleMockMixin
+from tests.support.mock import MagicMock, patch
+from tests.support.unit import TestCase
+
 # pylint: disable=invalid-name,protected-access,attribute-defined-outside-init,too-many-public-methods,unused-argument
 
 
 class LibvirtMock(MagicMock):  # pylint: disable=too-many-ancestors
-    '''
+    """
     Libvirt library mock
-    '''
+    """
+
     class virDomain(MagicMock):
-        '''
+        """
         virDomain mock
-        '''
+        """
 
     class libvirtError(Exception):
-        '''
+        """
         libvirtError mock
-        '''
+        """
+
+        def __init__(self, msg):
+            super().__init__(msg)
+            self.msg = msg
+
+        def get_error_message(self):
+            return self.msg
 
 
 class VirtTestCase(TestCase, LoaderModuleMockMixin):
-    '''
+    """
     Test cases for salt.module.virt
-    '''
+    """
 
     def setup_loader_modules(self):
         self.mock_libvirt = LibvirtMock()
         self.mock_conn = MagicMock()
+        self.mock_conn.getStoragePoolCapabilities.return_value = (
+            "<storagepoolCapabilities/>"
+        )
         self.mock_libvirt.openAuth.return_value = self.mock_conn
         self.mock_popen = MagicMock()
-        self.addCleanup(delattr, self, 'mock_libvirt')
-        self.addCleanup(delattr, self, 'mock_conn')
-        self.addCleanup(delattr, self, 'mock_popen')
+        self.addCleanup(delattr, self, "mock_libvirt")
+        self.addCleanup(delattr, self, "mock_conn")
+        self.addCleanup(delattr, self, "mock_popen")
         self.mock_subprocess = MagicMock()
-        self.mock_subprocess.return_value = self.mock_subprocess  # pylint: disable=no-member
-        self.mock_subprocess.Popen.return_value = self.mock_popen  # pylint: disable=no-member
+        self.mock_subprocess.return_value = (
+            self.mock_subprocess
+        )  # pylint: disable=no-member
+        self.mock_subprocess.Popen.return_value = (
+            self.mock_popen
+        )  # pylint: disable=no-member
         loader_globals = {
-            '__salt__': {
-                'config.get': config.get,
-                'config.option': config.option,
-            },
-            'libvirt': self.mock_libvirt,
-            'subprocess': self.mock_subprocess
+            "__salt__": {"config.get": config.get, "config.option": config.option},
+            "libvirt": self.mock_libvirt,
+            "subprocess": self.mock_subprocess,
         }
         return {virt: loader_globals, config: loader_globals}
 
     def set_mock_vm(self, name, xml):
-        '''
+        """
         Define VM to use in tests
-        '''
-        self.mock_conn.listDefinedDomains.return_value = [name]  # pylint: disable=no-member
+        """
+        self.mock_conn.listDefinedDomains.return_value = [
+            name
+        ]  # pylint: disable=no-member
         mock_domain = self.mock_libvirt.virDomain()
-        self.mock_conn.lookupByName.return_value = mock_domain  # pylint: disable=no-member
+        self.mock_conn.lookupByName.return_value = (
+            mock_domain  # pylint: disable=no-member
+        )
         mock_domain.XMLDesc.return_value = xml  # pylint: disable=no-member
 
         # Return state as shutdown
-        mock_domain.info.return_value = [4, 2048 * 1024, 1024 * 1024, 2, 1234]  # pylint: disable=no-member
+        mock_domain.info.return_value = [
+            4,
+            2048 * 1024,
+            1024 * 1024,
+            2,
+            1234,
+        ]  # pylint: disable=no-member
         mock_domain.ID.return_value = 1
         mock_domain.name.return_value = name
         return mock_domain
 
     def test_disk_profile_merge(self):
-        '''
+        """
         Test virt._disk_profile() when merging with user-defined disks
-        '''
-        root_dir = os.path.join(salt.syspaths.ROOT_DIR, 'srv', 'salt-images')
-        userdisks = [{'name': 'data', 'size': 16384, 'format': 'raw'}]
-
-        disks = virt._disk_profile('default', 'kvm', userdisks, 'myvm', image='/path/to/image')
-        self.assertEqual(
-            [{'name': 'system',
-              'device': 'disk',
-              'size': 8192,
-              'format': 'qcow2',
-              'model': 'virtio',
-              'filename': 'myvm_system.qcow2',
-              'image': '/path/to/image',
-              'source_file': '{0}{1}myvm_system.qcow2'.format(root_dir, os.sep)},
-             {'name': 'data',
-              'device': 'disk',
-              'size': 16384,
-              'format': 'raw',
-              'model': 'virtio',
-              'filename': 'myvm_data.raw',
-              'source_file': '{0}{1}myvm_data.raw'.format(root_dir, os.sep)}],
-            disks
+        """
+        root_dir = os.path.join(salt.syspaths.ROOT_DIR, "srv", "salt-images")
+        userdisks = [
+            {"name": "system", "image": "/path/to/image"},
+            {"name": "data", "size": 16384, "format": "raw"},
+        ]
+
+        disks = virt._disk_profile(self.mock_conn, "default", "kvm", userdisks, "myvm")
+        self.assertEqual(
+            [
+                {
+                    "name": "system",
+                    "device": "disk",
+                    "size": 8192,
+                    "format": "qcow2",
+                    "model": "virtio",
+                    "filename": "myvm_system.qcow2",
+                    "image": "/path/to/image",
+                    "source_file": "{0}{1}myvm_system.qcow2".format(root_dir, os.sep),
+                },
+                {
+                    "name": "data",
+                    "device": "disk",
+                    "size": 16384,
+                    "format": "raw",
+                    "model": "virtio",
+                    "filename": "myvm_data.raw",
+                    "source_file": "{0}{1}myvm_data.raw".format(root_dir, os.sep),
+                },
+            ],
+            disks,
         )
 
     def test_boot_default_dev(self):
-        '''
+        """
         Test virt._gen_xml() default boot device
-        '''
-        diskp = virt._disk_profile('default', 'kvm', [], 'hello')
-        nicp = virt._nic_profile('default', 'kvm')
+        """
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
         xml_data = virt._gen_xml(
-            'hello',
-            1,
-            512,
-            diskp,
-            nicp,
-            'kvm',
-            'hvm',
-            'x86_64'
-            )
+            self.mock_conn, "hello", 1, 512, diskp, nicp, "kvm", "hvm", "x86_64"
+        )
         root = ET.fromstring(xml_data)
-        self.assertEqual(root.find('os/boot').attrib['dev'], 'hd')
-        self.assertEqual(root.find('os/type').attrib['arch'], 'x86_64')
-        self.assertEqual(root.find('os/type').text, 'hvm')
+        self.assertEqual(root.find("os/boot").attrib["dev"], "hd")
+        self.assertEqual(root.find("os/type").attrib["arch"], "x86_64")
+        self.assertEqual(root.find("os/type").text, "hvm")
 
     def test_boot_custom_dev(self):
-        '''
+        """
         Test virt._gen_xml() custom boot device
-        '''
-        diskp = virt._disk_profile('default', 'kvm', [], 'hello')
-        nicp = virt._nic_profile('default', 'kvm')
+        """
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
         xml_data = virt._gen_xml(
-            'hello',
+            self.mock_conn,
+            "hello",
             1,
             512,
             diskp,
             nicp,
-            'kvm',
-            'hvm',
-            'x86_64',
-            boot_dev='cdrom'
-            )
+            "kvm",
+            "hvm",
+            "x86_64",
+            boot_dev="cdrom",
+        )
         root = ET.fromstring(xml_data)
-        self.assertEqual(root.find('os/boot').attrib['dev'], 'cdrom')
+        self.assertEqual(root.find("os/boot").attrib["dev"], "cdrom")
 
     def test_boot_multiple_devs(self):
-        '''
+        """
         Test virt._gen_xml() multiple boot devices
-        '''
-        diskp = virt._disk_profile('default', 'kvm', [], 'hello')
-        nicp = virt._nic_profile('default', 'kvm')
+        """
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
         xml_data = virt._gen_xml(
-            'hello',
+            self.mock_conn,
+            "hello",
             1,
             512,
             diskp,
             nicp,
-            'kvm',
-            'hvm',
-            'x86_64',
-            boot_dev='cdrom network'
-            )
+            "kvm",
+            "hvm",
+            "x86_64",
+            boot_dev="cdrom network",
+        )
         root = ET.fromstring(xml_data)
-        devs = root.findall('.//boot')
+        devs = root.findall(".//boot")
         self.assertTrue(len(devs) == 2)
 
     def test_gen_xml_no_nic(self):
-        '''
+        """
         Test virt._gen_xml() serial console
-        '''
-        diskp = virt._disk_profile('default', 'kvm', [], 'hello')
-        nicp = virt._nic_profile('default', 'kvm')
+        """
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
         xml_data = virt._gen_xml(
-            'hello',
+            self.mock_conn,
+            "hello",
             1,
             512,
             diskp,
             nicp,
-            'kvm',
-            'hvm',
-            'x86_64',
-            serial_type='pty',
-            console=True
-            )
+            "kvm",
+            "hvm",
+            "x86_64",
+            serial_type="pty",
+            console=True,
+        )
         root = ET.fromstring(xml_data)
-        self.assertEqual(root.find('devices/serial').attrib['type'], 'pty')
-        self.assertEqual(root.find('devices/console').attrib['type'], 'pty')
+        self.assertEqual(root.find("devices/serial").attrib["type"], "pty")
+        self.assertEqual(root.find("devices/console").attrib["type"], "pty")
 
     def test_gen_xml_for_serial_console(self):
-        '''
+        """
         Test virt._gen_xml() serial console
-        '''
-        diskp = virt._disk_profile('default', 'kvm', [], 'hello')
-        nicp = virt._nic_profile('default', 'kvm')
+        """
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
         xml_data = virt._gen_xml(
-            'hello',
+            self.mock_conn,
+            "hello",
             1,
             512,
             diskp,
             nicp,
-            'kvm',
-            'hvm',
-            'x86_64',
-            serial_type='pty',
-            console=True
-            )
+            "kvm",
+            "hvm",
+            "x86_64",
+            serial_type="pty",
+            console=True,
+        )
         root = ET.fromstring(xml_data)
-        self.assertEqual(root.find('devices/serial').attrib['type'], 'pty')
-        self.assertEqual(root.find('devices/console').attrib['type'], 'pty')
+        self.assertEqual(root.find("devices/serial").attrib["type"], "pty")
+        self.assertEqual(root.find("devices/console").attrib["type"], "pty")
 
     def test_gen_xml_for_telnet_console(self):
-        '''
+        """
         Test virt._gen_xml() telnet console
-        '''
-        diskp = virt._disk_profile('default', 'kvm', [], 'hello')
-        nicp = virt._nic_profile('default', 'kvm')
+        """
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
         xml_data = virt._gen_xml(
-            'hello',
+            self.mock_conn,
+            "hello",
             1,
             512,
             diskp,
             nicp,
-            'kvm',
-            'hvm',
-            'x86_64',
-            serial_type='tcp',
+            "kvm",
+            "hvm",
+            "x86_64",
+            serial_type="tcp",
             console=True,
-            telnet_port=22223
-            )
+            telnet_port=22223,
+        )
         root = ET.fromstring(xml_data)
-        self.assertEqual(root.find('devices/serial').attrib['type'], 'tcp')
-        self.assertEqual(root.find('devices/console').attrib['type'], 'tcp')
-        self.assertEqual(root.find('devices/console/source').attrib['service'], '22223')
+        self.assertEqual(root.find("devices/serial").attrib["type"], "tcp")
+        self.assertEqual(root.find("devices/console").attrib["type"], "tcp")
+        self.assertEqual(root.find("devices/console/source").attrib["service"], "22223")
 
     def test_gen_xml_for_telnet_console_unspecified_port(self):
-        '''
+        """
         Test virt._gen_xml() telnet console without any specified port
-        '''
-        diskp = virt._disk_profile('default', 'kvm', [], 'hello')
-        nicp = virt._nic_profile('default', 'kvm')
+        """
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
         xml_data = virt._gen_xml(
-            'hello',
+            self.mock_conn,
+            "hello",
             1,
             512,
             diskp,
             nicp,
-            'kvm',
-            'hvm',
-            'x86_64',
-            serial_type='tcp',
-            console=True
-            )
+            "kvm",
+            "hvm",
+            "x86_64",
+            serial_type="tcp",
+            console=True,
+        )
         root = ET.fromstring(xml_data)
-        self.assertEqual(root.find('devices/serial').attrib['type'], 'tcp')
-        self.assertEqual(root.find('devices/console').attrib['type'], 'tcp')
-        self.assertIsInstance(int(root.find('devices/console/source').attrib['service']), int)
+        self.assertEqual(root.find("devices/serial").attrib["type"], "tcp")
+        self.assertEqual(root.find("devices/console").attrib["type"], "tcp")
+        self.assertIsInstance(
+            int(root.find("devices/console/source").attrib["service"]), int
+        )
 
     def test_gen_xml_for_serial_no_console(self):
-        '''
+        """
         Test virt._gen_xml() with no serial console
-        '''
-        diskp = virt._disk_profile('default', 'kvm', [], 'hello')
-        nicp = virt._nic_profile('default', 'kvm')
+        """
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
         xml_data = virt._gen_xml(
-            'hello',
+            self.mock_conn,
+            "hello",
             1,
             512,
             diskp,
             nicp,
-            'kvm',
-            'hvm',
-            'x86_64',
-            serial_type='pty',
-            console=False
-            )
+            "kvm",
+            "hvm",
+            "x86_64",
+            serial_type="pty",
+            console=False,
+        )
         root = ET.fromstring(xml_data)
-        self.assertEqual(root.find('devices/serial').attrib['type'], 'pty')
-        self.assertEqual(root.find('devices/console'), None)
+        self.assertEqual(root.find("devices/serial").attrib["type"], "pty")
+        self.assertEqual(root.find("devices/console"), None)
 
     def test_gen_xml_for_telnet_no_console(self):
-        '''
+        """
         Test virt._gen_xml() with no telnet console
-        '''
-        diskp = virt._disk_profile('default', 'kvm', [], 'hello')
-        nicp = virt._nic_profile('default', 'kvm')
+        """
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
         xml_data = virt._gen_xml(
-            'hello',
+            self.mock_conn,
+            "hello",
             1,
             512,
             diskp,
             nicp,
-            'kvm',
-            'hvm',
-            'x86_64',
-            serial_type='tcp',
+            "kvm",
+            "hvm",
+            "x86_64",
+            serial_type="tcp",
             console=False,
-            )
+        )
         root = ET.fromstring(xml_data)
-        self.assertEqual(root.find('devices/serial').attrib['type'], 'tcp')
-        self.assertEqual(root.find('devices/console'), None)
+        self.assertEqual(root.find("devices/serial").attrib["type"], "tcp")
+        self.assertEqual(root.find("devices/console"), None)
 
     def test_gen_xml_nographics_default(self):
-        '''
+        """
         Test virt._gen_xml() with default no graphics device
-        '''
-        diskp = virt._disk_profile('default', 'kvm', [], 'hello')
-        nicp = virt._nic_profile('default', 'kvm')
+        """
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
         xml_data = virt._gen_xml(
-            'hello',
-            1,
-            512,
-            diskp,
-            nicp,
-            'kvm',
-            'hvm',
-            'x86_64'
-            )
+            self.mock_conn, "hello", 1, 512, diskp, nicp, "kvm", "hvm", "x86_64"
+        )
+        root = ET.fromstring(xml_data)
+        self.assertIsNone(root.find("devices/graphics"))
+
+    def test_gen_xml_noloader_default(self):
+        """
+        Test virt._gen_xml() with default no loader
+        """
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
+        xml_data = virt._gen_xml(
+            self.mock_conn, "hello", 1, 512, diskp, nicp, "kvm", "hvm", "x86_64"
+        )
         root = ET.fromstring(xml_data)
-        self.assertIsNone(root.find('devices/graphics'))
+        self.assertIsNone(root.find("os/loader"))
 
     def test_gen_xml_vnc_default(self):
-        '''
+        """
         Test virt._gen_xml() with default vnc graphics device
-        '''
-        diskp = virt._disk_profile('default', 'kvm', [], 'hello')
-        nicp = virt._nic_profile('default', 'kvm')
+        """
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
         xml_data = virt._gen_xml(
-            'hello',
+            self.mock_conn,
+            "hello",
             1,
             512,
             diskp,
             nicp,
-            'kvm',
-            'hvm',
-            'x86_64',
-            graphics={'type': 'vnc', 'port': 1234, 'tlsPort': 5678,
-                      'listen': {'type': 'address', 'address': 'myhost'}},
-            )
+            "kvm",
+            "hvm",
+            "x86_64",
+            graphics={
+                "type": "vnc",
+                "port": 1234,
+                "tlsPort": 5678,
+                "listen": {"type": "address", "address": "myhost"},
+            },
+        )
         root = ET.fromstring(xml_data)
-        self.assertEqual(root.find('devices/graphics').attrib['type'], 'vnc')
-        self.assertEqual(root.find('devices/graphics').attrib['autoport'], 'no')
-        self.assertEqual(root.find('devices/graphics').attrib['port'], '1234')
-        self.assertFalse('tlsPort' in root.find('devices/graphics').attrib)
-        self.assertEqual(root.find('devices/graphics').attrib['listen'], 'myhost')
-        self.assertEqual(root.find('devices/graphics/listen').attrib['type'], 'address')
-        self.assertEqual(root.find('devices/graphics/listen').attrib['address'], 'myhost')
+        self.assertEqual(root.find("devices/graphics").attrib["type"], "vnc")
+        self.assertEqual(root.find("devices/graphics").attrib["autoport"], "no")
+        self.assertEqual(root.find("devices/graphics").attrib["port"], "1234")
+        self.assertFalse("tlsPort" in root.find("devices/graphics").attrib)
+        self.assertEqual(root.find("devices/graphics").attrib["listen"], "myhost")
+        self.assertEqual(root.find("devices/graphics/listen").attrib["type"], "address")
+        self.assertEqual(
+            root.find("devices/graphics/listen").attrib["address"], "myhost"
+        )
 
     def test_gen_xml_spice_default(self):
-        '''
+        """
         Test virt._gen_xml() with default spice graphics device
-        '''
-        diskp = virt._disk_profile('default', 'kvm', [], 'hello')
-        nicp = virt._nic_profile('default', 'kvm')
+        """
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
         xml_data = virt._gen_xml(
-            'hello',
+            self.mock_conn,
+            "hello",
             1,
             512,
             diskp,
             nicp,
-            'kvm',
-            'hvm',
-            'x86_64',
-            graphics={'type': 'spice'},
-            )
+            "kvm",
+            "hvm",
+            "x86_64",
+            graphics={"type": "spice"},
+        )
         root = ET.fromstring(xml_data)
-        self.assertEqual(root.find('devices/graphics').attrib['type'], 'spice')
-        self.assertEqual(root.find('devices/graphics').attrib['autoport'], 'yes')
-        self.assertEqual(root.find('devices/graphics').attrib['listen'], '0.0.0.0')
-        self.assertEqual(root.find('devices/graphics/listen').attrib['type'], 'address')
-        self.assertEqual(root.find('devices/graphics/listen').attrib['address'], '0.0.0.0')
+        self.assertEqual(root.find("devices/graphics").attrib["type"], "spice")
+        self.assertEqual(root.find("devices/graphics").attrib["autoport"], "yes")
+        self.assertEqual(root.find("devices/graphics").attrib["listen"], "0.0.0.0")
+        self.assertEqual(root.find("devices/graphics/listen").attrib["type"], "address")
+        self.assertEqual(
+            root.find("devices/graphics/listen").attrib["address"], "0.0.0.0"
+        )
 
     def test_gen_xml_spice(self):
-        '''
+        """
         Test virt._gen_xml() with spice graphics device
-        '''
-        diskp = virt._disk_profile('default', 'kvm', [], 'hello')
-        nicp = virt._nic_profile('default', 'kvm')
+        """
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
         xml_data = virt._gen_xml(
-            'hello',
+            self.mock_conn,
+            "hello",
             1,
             512,
             diskp,
             nicp,
-            'kvm',
-            'hvm',
-            'x86_64',
-            graphics={'type': 'spice', 'port': 1234, 'tls_port': 5678, 'listen': {'type': 'none'}},
-            )
+            "kvm",
+            "hvm",
+            "x86_64",
+            graphics={
+                "type": "spice",
+                "port": 1234,
+                "tls_port": 5678,
+                "listen": {"type": "none"},
+            },
+        )
         root = ET.fromstring(xml_data)
-        self.assertEqual(root.find('devices/graphics').attrib['type'], 'spice')
-        self.assertEqual(root.find('devices/graphics').attrib['autoport'], 'no')
-        self.assertEqual(root.find('devices/graphics').attrib['port'], '1234')
-        self.assertEqual(root.find('devices/graphics').attrib['tlsPort'], '5678')
-        self.assertFalse('listen' in root.find('devices/graphics').attrib)
-        self.assertEqual(root.find('devices/graphics/listen').attrib['type'], 'none')
-        self.assertFalse('address' in root.find('devices/graphics/listen').attrib)
+        self.assertEqual(root.find("devices/graphics").attrib["type"], "spice")
+        self.assertEqual(root.find("devices/graphics").attrib["autoport"], "no")
+        self.assertEqual(root.find("devices/graphics").attrib["port"], "1234")
+        self.assertEqual(root.find("devices/graphics").attrib["tlsPort"], "5678")
+        self.assertFalse("listen" in root.find("devices/graphics").attrib)
+        self.assertEqual(root.find("devices/graphics/listen").attrib["type"], "none")
+        self.assertFalse("address" in root.find("devices/graphics/listen").attrib)
 
     def test_default_disk_profile_hypervisor_esxi(self):
-        '''
+        """
         Test virt._disk_profile() default ESXi profile
-        '''
+        """
         mock = MagicMock(return_value={})
-        with patch.dict(virt.__salt__, {'config.get': mock}):  # pylint: disable=no-member
-            ret = virt._disk_profile('nonexistent', 'vmware')
+        with patch.dict(
+            virt.__salt__, {"config.get": mock}  # pylint: disable=no-member
+        ):
+            ret = virt._disk_profile(
+                self.mock_conn, "nonexistent", "vmware", None, "test-vm"
+            )
             self.assertTrue(len(ret) == 1)
-            found = [disk for disk in ret if disk['name'] == 'system']
+            found = [disk for disk in ret if disk["name"] == "system"]
             self.assertTrue(bool(found))
             system = found[0]
-            self.assertEqual(system['format'], 'vmdk')
-            self.assertEqual(system['model'], 'scsi')
-            self.assertTrue(int(system['size']) >= 1)
+            self.assertEqual(system["format"], "vmdk")
+            self.assertEqual(system["model"], "scsi")
+            self.assertTrue(int(system["size"]) >= 1)
 
     def test_default_disk_profile_hypervisor_kvm(self):
-        '''
+        """
         Test virt._disk_profile() default KVM profile
-        '''
-        mock = MagicMock(return_value={})
-        with patch.dict(virt.__salt__, {'config.get': mock}):  # pylint: disable=no-member
-            ret = virt._disk_profile('nonexistent', 'kvm')
+        """
+        mock = MagicMock(side_effect=[{}, "/images/dir"])
+        with patch.dict(
+            virt.__salt__, {"config.get": mock}  # pylint: disable=no-member
+        ):
+            ret = virt._disk_profile(
+                self.mock_conn, "nonexistent", "kvm", None, "test-vm"
+            )
             self.assertTrue(len(ret) == 1)
-            found = [disk for disk in ret if disk['name'] == 'system']
+            found = [disk for disk in ret if disk["name"] == "system"]
             self.assertTrue(bool(found))
             system = found[0]
-            self.assertEqual(system['format'], 'qcow2')
-            self.assertEqual(system['model'], 'virtio')
-            self.assertTrue(int(system['size']) >= 1)
+            self.assertEqual(system["format"], "qcow2")
+            self.assertEqual(system["model"], "virtio")
+            self.assertTrue(int(system["size"]) >= 1)
 
     def test_default_disk_profile_hypervisor_xen(self):
-        '''
+        """
         Test virt._disk_profile() default XEN profile
-        '''
-        mock = MagicMock(return_value={})
-        with patch.dict(virt.__salt__, {'config.get': mock}):  # pylint: disable=no-member
-            ret = virt._disk_profile('nonexistent', 'xen')
+        """
+        mock = MagicMock(side_effect=[{}, "/images/dir"])
+        with patch.dict(
+            virt.__salt__, {"config.get": mock}  # pylint: disable=no-member
+        ):
+            ret = virt._disk_profile(
+                self.mock_conn, "nonexistent", "xen", None, "test-vm"
+            )
             self.assertTrue(len(ret) == 1)
-            found = [disk for disk in ret if disk['name'] == 'system']
+            found = [disk for disk in ret if disk["name"] == "system"]
             self.assertTrue(bool(found))
             system = found[0]
-            self.assertEqual(system['format'], 'qcow2')
-            self.assertEqual(system['model'], 'xen')
-            self.assertTrue(int(system['size']) >= 1)
+            self.assertEqual(system["format"], "qcow2")
+            self.assertEqual(system["model"], "xen")
+            self.assertTrue(int(system["size"]) >= 1)
 
     def test_default_nic_profile_hypervisor_esxi(self):
-        '''
+        """
         Test virt._nic_profile() default ESXi profile
-        '''
+        """
         mock = MagicMock(return_value={})
-        with patch.dict(virt.__salt__, {'config.get': mock}):  # pylint: disable=no-member
-            ret = virt._nic_profile('nonexistent', 'vmware')
+        with patch.dict(
+            virt.__salt__, {"config.get": mock}  # pylint: disable=no-member
+        ):
+            ret = virt._nic_profile("nonexistent", "vmware")
             self.assertTrue(len(ret) == 1)
             eth0 = ret[0]
-            self.assertEqual(eth0['name'], 'eth0')
-            self.assertEqual(eth0['type'], 'bridge')
-            self.assertEqual(eth0['source'], 'DEFAULT')
-            self.assertEqual(eth0['model'], 'e1000')
+            self.assertEqual(eth0["name"], "eth0")
+            self.assertEqual(eth0["type"], "bridge")
+            self.assertEqual(eth0["source"], "DEFAULT")
+            self.assertEqual(eth0["model"], "e1000")
 
     def test_default_nic_profile_hypervisor_kvm(self):
-        '''
+        """
         Test virt._nic_profile() default KVM profile
-        '''
+        """
         mock = MagicMock(return_value={})
-        with patch.dict(virt.__salt__, {'config.get': mock}):  # pylint: disable=no-member
-            ret = virt._nic_profile('nonexistent', 'kvm')
+        with patch.dict(
+            virt.__salt__, {"config.get": mock}  # pylint: disable=no-member
+        ):
+            ret = virt._nic_profile("nonexistent", "kvm")
             self.assertTrue(len(ret) == 1)
             eth0 = ret[0]
-            self.assertEqual(eth0['name'], 'eth0')
-            self.assertEqual(eth0['type'], 'bridge')
-            self.assertEqual(eth0['source'], 'br0')
-            self.assertEqual(eth0['model'], 'virtio')
+            self.assertEqual(eth0["name"], "eth0")
+            self.assertEqual(eth0["type"], "bridge")
+            self.assertEqual(eth0["source"], "br0")
+            self.assertEqual(eth0["model"], "virtio")
 
     def test_default_nic_profile_hypervisor_xen(self):
-        '''
+        """
         Test virt._nic_profile() default XEN profile
-        '''
+        """
         mock = MagicMock(return_value={})
-        with patch.dict(virt.__salt__, {'config.get': mock}):  # pylint: disable=no-member
-            ret = virt._nic_profile('nonexistent', 'xen')
+        with patch.dict(
+            virt.__salt__, {"config.get": mock}  # pylint: disable=no-member
+        ):
+            ret = virt._nic_profile("nonexistent", "xen")
             self.assertTrue(len(ret) == 1)
             eth0 = ret[0]
-            self.assertEqual(eth0['name'], 'eth0')
-            self.assertEqual(eth0['type'], 'bridge')
-            self.assertEqual(eth0['source'], 'br0')
-            self.assertFalse(eth0['model'])
-
-    def test_gen_vol_xml(self):
-        '''
-        Test virt._get_vol_xml()
-        '''
-        xml_data = virt._gen_vol_xml('vmname', 'system', 'qcow2', 8192, '/path/to/image/')
+            self.assertEqual(eth0["name"], "eth0")
+            self.assertEqual(eth0["type"], "bridge")
+            self.assertEqual(eth0["source"], "br0")
+            self.assertFalse(eth0["model"])
+
+    def test_gen_vol_xml_esx(self):
+        """
+        Test virt._get_vol_xml() for the ESX case
+        """
+        xml_data = virt._gen_vol_xml("vmname/system.vmdk", 8192, format="vmdk")
+        root = ET.fromstring(xml_data)
+        self.assertIsNone(root.get("type"))
+        self.assertEqual(root.find("name").text, "vmname/system.vmdk")
+        self.assertEqual(root.find("capacity").attrib["unit"], "KiB")
+        self.assertEqual(root.find("capacity").text, six.text_type(8192 * 1024))
+        self.assertEqual(root.find("allocation").text, six.text_type(0))
+        self.assertEqual(root.find("target/format").get("type"), "vmdk")
+        self.assertIsNone(root.find("target/permissions"))
+        self.assertIsNone(root.find("target/nocow"))
+        self.assertIsNone(root.find("backingStore"))
+
+    def test_gen_vol_xml_file(self):
+        """
+        Test virt._get_vol_xml() for a file volume
+        """
+        xml_data = virt._gen_vol_xml(
+            "myvm_system.qcow2",
+            8192,
+            format="qcow2",
+            allocation=4096,
+            type="file",
+            permissions={
+                "mode": "0775",
+                "owner": "123",
+                "group": "456",
+                "label": "sec_label",
+            },
+            backing_store={"path": "/backing/image", "format": "raw"},
+            nocow=True,
+        )
         root = ET.fromstring(xml_data)
-        self.assertEqual(root.find('name').text, 'vmname/system.qcow2')
-        self.assertEqual(root.find('key').text, 'vmname/system')
-        self.assertEqual(root.find('capacity').attrib['unit'], 'KiB')
-        self.assertEqual(root.find('capacity').text, six.text_type(8192 * 1024))
+        self.assertEqual(root.get("type"), "file")
+        self.assertEqual(root.find("name").text, "myvm_system.qcow2")
+        self.assertIsNone(root.find("key"))
+        self.assertIsNone(root.find("target/path"))
+        self.assertEqual(root.find("target/format").get("type"), "qcow2")
+        self.assertEqual(root.find("capacity").attrib["unit"], "KiB")
+        self.assertEqual(root.find("capacity").text, six.text_type(8192 * 1024))
+        self.assertEqual(root.find("capacity").attrib["unit"], "KiB")
+        self.assertEqual(root.find("allocation").text, six.text_type(4096 * 1024))
+        self.assertEqual(root.find("target/permissions/mode").text, "0775")
+        self.assertEqual(root.find("target/permissions/owner").text, "123")
+        self.assertEqual(root.find("target/permissions/group").text, "456")
+        self.assertEqual(root.find("target/permissions/label").text, "sec_label")
+        self.assertIsNotNone(root.find("target/nocow"))
+        self.assertEqual(root.find("backingStore/path").text, "/backing/image")
+        self.assertEqual(root.find("backingStore/format").get("type"), "raw")
 
     def test_gen_xml_for_kvm_default_profile(self):
-        '''
+        """
         Test virt._gen_xml(), KVM default profile case
-        '''
-        diskp = virt._disk_profile('default', 'kvm', [], 'hello')
-        nicp = virt._nic_profile('default', 'kvm')
+        """
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
         xml_data = virt._gen_xml(
-            'hello',
-            1,
-            512,
-            diskp,
-            nicp,
-            'kvm',
-            'hvm',
-            'x86_64',
-            )
+            self.mock_conn, "hello", 1, 512, diskp, nicp, "kvm", "hvm", "x86_64",
+        )
         root = ET.fromstring(xml_data)
-        self.assertEqual(root.attrib['type'], 'kvm')
-        self.assertEqual(root.find('vcpu').text, '1')
-        self.assertEqual(root.find('memory').text, six.text_type(512 * 1024))
-        self.assertEqual(root.find('memory').attrib['unit'], 'KiB')
+        self.assertEqual(root.attrib["type"], "kvm")
+        self.assertEqual(root.find("vcpu").text, "1")
+        self.assertEqual(root.find("memory").text, six.text_type(512 * 1024))
+        self.assertEqual(root.find("memory").attrib["unit"], "KiB")
 
-        disks = root.findall('.//disk')
+        disks = root.findall(".//disk")
         self.assertEqual(len(disks), 1)
         disk = disks[0]
-        root_dir = salt.config.DEFAULT_MINION_OPTS.get('root_dir')
-        self.assertTrue(disk.find('source').attrib['file'].startswith(root_dir))
-        self.assertTrue('hello_system' in disk.find('source').attrib['file'])
-        self.assertEqual(disk.find('target').attrib['dev'], 'vda')
-        self.assertEqual(disk.find('target').attrib['bus'], 'virtio')
-        self.assertEqual(disk.find('driver').attrib['name'], 'qemu')
-        self.assertEqual(disk.find('driver').attrib['type'], 'qcow2')
-
-        interfaces = root.findall('.//interface')
+        root_dir = salt.config.DEFAULT_MINION_OPTS.get("root_dir")
+        self.assertTrue(disk.find("source").attrib["file"].startswith(root_dir))
+        self.assertTrue("hello_system" in disk.find("source").attrib["file"])
+        self.assertEqual(disk.find("target").attrib["dev"], "vda")
+        self.assertEqual(disk.find("target").attrib["bus"], "virtio")
+        self.assertEqual(disk.find("driver").attrib["name"], "qemu")
+        self.assertEqual(disk.find("driver").attrib["type"], "qcow2")
+
+        interfaces = root.findall(".//interface")
         self.assertEqual(len(interfaces), 1)
         iface = interfaces[0]
-        self.assertEqual(iface.attrib['type'], 'bridge')
-        self.assertEqual(iface.find('source').attrib['bridge'], 'br0')
-        self.assertEqual(iface.find('model').attrib['type'], 'virtio')
-
-        mac = iface.find('mac').attrib['address']
-        self.assertTrue(
-              re.match('^([0-9A-F]{2}[:-]){5}([0-9A-F]{2})$', mac, re.I))
+        self.assertEqual(iface.attrib["type"], "bridge")
+        self.assertEqual(iface.find("source").attrib["bridge"], "br0")
+        self.assertEqual(iface.find("model").attrib["type"], "virtio")
 
     def test_gen_xml_for_esxi_default_profile(self):
-        '''
+        """
         Test virt._gen_xml(), ESXi/vmware default profile case
-        '''
-        diskp = virt._disk_profile('default', 'vmware', [], 'hello')
-        nicp = virt._nic_profile('default', 'vmware')
+        """
+        diskp = virt._disk_profile(self.mock_conn, "default", "vmware", [], "hello")
+        nicp = virt._nic_profile("default", "vmware")
         xml_data = virt._gen_xml(
-            'hello',
-            1,
-            512,
-            diskp,
-            nicp,
-            'vmware',
-            'hvm',
-            'x86_64',
-            )
+            self.mock_conn, "hello", 1, 512, diskp, nicp, "vmware", "hvm", "x86_64",
+        )
         root = ET.fromstring(xml_data)
-        self.assertEqual(root.attrib['type'], 'vmware')
-        self.assertEqual(root.find('vcpu').text, '1')
-        self.assertEqual(root.find('memory').text, six.text_type(512 * 1024))
-        self.assertEqual(root.find('memory').attrib['unit'], 'KiB')
+        self.assertEqual(root.attrib["type"], "vmware")
+        self.assertEqual(root.find("vcpu").text, "1")
+        self.assertEqual(root.find("memory").text, six.text_type(512 * 1024))
+        self.assertEqual(root.find("memory").attrib["unit"], "KiB")
 
-        disks = root.findall('.//disk')
+        disks = root.findall(".//disk")
         self.assertEqual(len(disks), 1)
         disk = disks[0]
-        self.assertTrue('[0]' in disk.find('source').attrib['file'])
-        self.assertTrue('hello_system' in disk.find('source').attrib['file'])
-        self.assertEqual(disk.find('target').attrib['dev'], 'sda')
-        self.assertEqual(disk.find('target').attrib['bus'], 'scsi')
-        self.assertEqual(disk.find('address').attrib['unit'], '0')
+        self.assertTrue("[0]" in disk.find("source").attrib["file"])
+        self.assertTrue("hello_system" in disk.find("source").attrib["file"])
+        self.assertEqual(disk.find("target").attrib["dev"], "sda")
+        self.assertEqual(disk.find("target").attrib["bus"], "scsi")
+        self.assertEqual(disk.find("address").attrib["unit"], "0")
 
-        interfaces = root.findall('.//interface')
+        interfaces = root.findall(".//interface")
         self.assertEqual(len(interfaces), 1)
         iface = interfaces[0]
-        self.assertEqual(iface.attrib['type'], 'bridge')
-        self.assertEqual(iface.find('source').attrib['bridge'], 'DEFAULT')
-        self.assertEqual(iface.find('model').attrib['type'], 'e1000')
-
-        mac = iface.find('mac').attrib['address']
-        self.assertTrue(
-              re.match('^([0-9A-F]{2}[:-]){5}([0-9A-F]{2})$', mac, re.I))
+        self.assertEqual(iface.attrib["type"], "bridge")
+        self.assertEqual(iface.find("source").attrib["bridge"], "DEFAULT")
+        self.assertEqual(iface.find("model").attrib["type"], "e1000")
 
     def test_gen_xml_for_xen_default_profile(self):
-        '''
+        """
         Test virt._gen_xml(), XEN PV default profile case
-        '''
-        diskp = virt._disk_profile('default', 'xen', [], 'hello')
-        nicp = virt._nic_profile('default', 'xen')
-        with patch.dict(virt.__grains__, {'os_family': 'Suse'}):
+        """
+        diskp = virt._disk_profile(self.mock_conn, "default", "xen", [], "hello")
+        nicp = virt._nic_profile("default", "xen")
+        with patch.dict(
+            virt.__grains__, {"os_family": "Suse"}  # pylint: disable=no-member
+        ):
             xml_data = virt._gen_xml(
-                'hello',
+                self.mock_conn,
+                "hello",
                 1,
                 512,
                 diskp,
                 nicp,
-                'xen',
-                'xen',
-                'x86_64',
-                boot=None
-                )
+                "xen",
+                "xen",
+                "x86_64",
+                boot=None,
+            )
             root = ET.fromstring(xml_data)
-            self.assertEqual(root.attrib['type'], 'xen')
-            self.assertEqual(root.find('vcpu').text, '1')
-            self.assertEqual(root.find('memory').text, six.text_type(512 * 1024))
-            self.assertEqual(root.find('memory').attrib['unit'], 'KiB')
-            self.assertEqual(root.find('.//kernel').text, '/usr/lib/grub2/x86_64-xen/grub.xen')
+            self.assertEqual(root.attrib["type"], "xen")
+            self.assertEqual(root.find("vcpu").text, "1")
+            self.assertEqual(root.find("memory").text, six.text_type(512 * 1024))
+            self.assertEqual(root.find("memory").attrib["unit"], "KiB")
+            self.assertEqual(
+                root.find(".//kernel").text, "/usr/lib/grub2/x86_64-xen/grub.xen"
+            )
 
-            disks = root.findall('.//disk')
+            disks = root.findall(".//disk")
             self.assertEqual(len(disks), 1)
             disk = disks[0]
-            root_dir = salt.config.DEFAULT_MINION_OPTS.get('root_dir')
-            self.assertTrue(disk.find('source').attrib['file'].startswith(root_dir))
-            self.assertTrue('hello_system' in disk.find('source').attrib['file'])
-            self.assertEqual(disk.find('target').attrib['dev'], 'xvda')
-            self.assertEqual(disk.find('target').attrib['bus'], 'xen')
-            self.assertEqual(disk.find('driver').attrib['name'], 'qemu')
-            self.assertEqual(disk.find('driver').attrib['type'], 'qcow2')
-
-            interfaces = root.findall('.//interface')
+            root_dir = salt.config.DEFAULT_MINION_OPTS.get("root_dir")
+            self.assertTrue(disk.find("source").attrib["file"].startswith(root_dir))
+            self.assertTrue("hello_system" in disk.find("source").attrib["file"])
+            self.assertEqual(disk.find("target").attrib["dev"], "xvda")
+            self.assertEqual(disk.find("target").attrib["bus"], "xen")
+            self.assertEqual(disk.find("driver").attrib["name"], "qemu")
+            self.assertEqual(disk.find("driver").attrib["type"], "qcow2")
+
+            interfaces = root.findall(".//interface")
             self.assertEqual(len(interfaces), 1)
             iface = interfaces[0]
-            self.assertEqual(iface.attrib['type'], 'bridge')
-            self.assertEqual(iface.find('source').attrib['bridge'], 'br0')
-            self.assertIsNone(iface.find('model'))
+            self.assertEqual(iface.attrib["type"], "bridge")
+            self.assertEqual(iface.find("source").attrib["bridge"], "br0")
+            self.assertIsNone(iface.find("model"))
 
     def test_gen_xml_for_esxi_custom_profile(self):
-        '''
+        """
         Test virt._gen_xml(), ESXi/vmware custom profile case
-        '''
+        """
         disks = {
-            'noeffect': [
-                {'first': {'size': 8192, 'pool': 'datastore1'}},
-                {'second': {'size': 4096, 'pool': 'datastore2'}}
+            "noeffect": [
+                {"first": {"size": 8192, "pool": "datastore1"}},
+                {"second": {"size": 4096, "pool": "datastore2"}},
             ]
         }
         nics = {
-            'noeffect': [
-                {'name': 'eth1', 'source': 'ONENET'},
-                {'name': 'eth2', 'source': 'TWONET'}
+            "noeffect": [
+                {"name": "eth1", "source": "ONENET"},
+                {"name": "eth2", "source": "TWONET"},
             ]
         }
-        with patch.dict(virt.__salt__,  # pylint: disable=no-member
-                        {'config.get': MagicMock(side_effect=[disks, nics])}):
-            diskp = virt._disk_profile('noeffect', 'vmware', [], 'hello')
-            nicp = virt._nic_profile('noeffect', 'vmware')
+        with patch.dict(
+            virt.__salt__,  # pylint: disable=no-member
+            {"config.get": MagicMock(side_effect=[disks, nics])},
+        ):
+            diskp = virt._disk_profile(
+                self.mock_conn, "noeffect", "vmware", [], "hello"
+            )
+            nicp = virt._nic_profile("noeffect", "vmware")
             xml_data = virt._gen_xml(
-                'hello',
-                1,
-                512,
-                diskp,
-                nicp,
-                'vmware',
-                'hvm',
-                'x86_64',
-                )
+                self.mock_conn, "hello", 1, 512, diskp, nicp, "vmware", "hvm", "x86_64",
+            )
             root = ET.fromstring(xml_data)
-            self.assertEqual(root.attrib['type'], 'vmware')
-            self.assertEqual(root.find('vcpu').text, '1')
-            self.assertEqual(root.find('memory').text, six.text_type(512 * 1024))
-            self.assertEqual(root.find('memory').attrib['unit'], 'KiB')
-            self.assertTrue(len(root.findall('.//disk')) == 2)
-            self.assertTrue(len(root.findall('.//interface')) == 2)
+            self.assertEqual(root.attrib["type"], "vmware")
+            self.assertEqual(root.find("vcpu").text, "1")
+            self.assertEqual(root.find("memory").text, six.text_type(512 * 1024))
+            self.assertEqual(root.find("memory").attrib["unit"], "KiB")
+            self.assertTrue(len(root.findall(".//disk")) == 2)
+            self.assertTrue(len(root.findall(".//interface")) == 2)
 
     def test_gen_xml_for_kvm_custom_profile(self):
-        '''
+        """
         Test virt._gen_xml(), KVM custom profile case
-        '''
+        """
         disks = {
-            'noeffect': [
-                {'first': {'size': 8192, 'pool': '/var/lib/images'}},
-                {'second': {'size': 4096, 'pool': '/var/lib/images'}}
+            "noeffect": [
+                {"first": {"size": 8192, "pool": "/var/lib/images"}},
+                {"second": {"size": 4096, "pool": "/var/lib/images"}},
             ]
         }
         nics = {
-            'noeffect': [
-                {'name': 'eth1', 'source': 'b2'},
-                {'name': 'eth2', 'source': 'b2'}
+            "noeffect": [
+                {"name": "eth1", "source": "b2"},
+                {"name": "eth2", "source": "b2"},
             ]
         }
-        with patch.dict(virt.__salt__, {'config.get': MagicMock(side_effect=[  # pylint: disable=no-member
-                disks, nics])}):
-            diskp = virt._disk_profile('noeffect', 'kvm', [], 'hello')
-            nicp = virt._nic_profile('noeffect', 'kvm')
+        with patch.dict(
+            virt.__salt__,  # pylint: disable=no-member
+            {"config.get": MagicMock(side_effect=[disks, nics])},
+        ):
+            diskp = virt._disk_profile(self.mock_conn, "noeffect", "kvm", [], "hello")
+            nicp = virt._nic_profile("noeffect", "kvm")
             xml_data = virt._gen_xml(
-                'hello',
-                1,
-                512,
-                diskp,
-                nicp,
-                'kvm',
-                'hvm',
-                'x86_64',
-                )
+                self.mock_conn, "hello", 1, 512, diskp, nicp, "kvm", "hvm", "x86_64",
+            )
             root = ET.fromstring(xml_data)
-            self.assertEqual(root.attrib['type'], 'kvm')
-            self.assertEqual(root.find('vcpu').text, '1')
-            self.assertEqual(root.find('memory').text, six.text_type(512 * 1024))
-            self.assertEqual(root.find('memory').attrib['unit'], 'KiB')
-            self.assertTrue(len(root.findall('.//disk')) == 2)
-            self.assertTrue(len(root.findall('.//interface')) == 2)
-
-    @patch('salt.modules.virt.pool_info',
-           return_value={'mypool': {'target_path': os.path.join(salt.syspaths.ROOT_DIR, 'pools', 'mypool')}})
-    def test_disk_profile_kvm_disk_pool(self, mock_poolinfo):
-        '''
-        Test virt._gen_xml(), KVM case with pools defined.
-        '''
+            self.assertEqual(root.attrib["type"], "kvm")
+            self.assertEqual(root.find("vcpu").text, "1")
+            self.assertEqual(root.find("memory").text, six.text_type(512 * 1024))
+            self.assertEqual(root.find("memory").attrib["unit"], "KiB")
+            disks = root.findall(".//disk")
+            self.assertTrue(len(disks) == 2)
+            self.assertEqual(disks[0].find("target").get("dev"), "vda")
+            self.assertEqual(disks[1].find("target").get("dev"), "vdb")
+            self.assertTrue(len(root.findall(".//interface")) == 2)
+
+    def test_disk_profile_kvm_disk_pool(self):
+        """
+        Test virt._disk_profile(), KVM case with pools defined.
+        """
         disks = {
-            'noeffect': [
-                {'first': {'size': 8192, 'pool': 'mypool'}},
-                {'second': {'size': 4096}}
+            "noeffect": [
+                {"first": {"size": 8192, "pool": "mypool"}},
+                {"second": {"size": 4096}},
             ]
         }
 
         # pylint: disable=no-member
-        with patch.dict(virt.__salt__, {'config.get': MagicMock(side_effect=[
-                disks,
-                os.path.join(salt.syspaths.ROOT_DIR, 'default', 'path')])}):
+        with patch.dict(
+            virt.__salt__,
+            {
+                "config.get": MagicMock(
+                    side_effect=[
+                        disks,
+                        os.path.join(salt.syspaths.ROOT_DIR, "default", "path"),
+                    ]
+                )
+            },
+        ):
 
-            diskp = virt._disk_profile('noeffect', 'kvm', [], 'hello')
+            diskp = virt._disk_profile(self.mock_conn, "noeffect", "kvm", [], "hello")
 
-            pools_path = os.path.join(salt.syspaths.ROOT_DIR, 'pools', 'mypool') + os.sep
-            default_path = os.path.join(salt.syspaths.ROOT_DIR, 'default', 'path') + os.sep
+            pools_path = (
+                os.path.join(salt.syspaths.ROOT_DIR, "pools", "mypool") + os.sep
+            )
+            default_path = (
+                os.path.join(salt.syspaths.ROOT_DIR, "default", "path") + os.sep
+            )
 
             self.assertEqual(len(diskp), 2)
-            self.assertTrue(diskp[0]['source_file'].startswith(pools_path))
-            self.assertTrue(diskp[1]['source_file'].startswith(default_path))
+            self.assertTrue(diskp[1]["source_file"].startswith(default_path))
         # pylint: enable=no-member
 
     def test_disk_profile_kvm_disk_external_image(self):
-        '''
+        """
         Test virt._gen_xml(), KVM case with an external image.
-        '''
-        diskp = virt._disk_profile(None, 'kvm', [
+        """
+        with patch.dict(os.path.__dict__, {"exists": MagicMock(return_value=True)}):
+            diskp = virt._disk_profile(
+                self.mock_conn,
+                None,
+                "kvm",
+                [{"name": "mydisk", "source_file": "/path/to/my/image.qcow2"}],
+                "hello",
+            )
+
+            self.assertEqual(len(diskp), 1)
+            self.assertEqual(diskp[0]["source_file"], ("/path/to/my/image.qcow2"))
+
+    def test_disk_profile_cdrom_default(self):
+        """
+        Test virt._gen_xml(), KVM case with cdrom.
+        """
+        with patch.dict(os.path.__dict__, {"exists": MagicMock(return_value=True)}):
+            diskp = virt._disk_profile(
+                self.mock_conn,
+                None,
+                "kvm",
+                [
+                    {
+                        "name": "mydisk",
+                        "device": "cdrom",
+                        "source_file": "/path/to/my.iso",
+                    }
+                ],
+                "hello",
+            )
+
+            self.assertEqual(len(diskp), 1)
+            self.assertEqual(diskp[0]["model"], "ide")
+            self.assertEqual(diskp[0]["format"], "raw")
+
+    def test_disk_profile_pool_disk_type(self):
+        """
+        Test virt._disk_profile(), with a disk pool of disk type
+        """
+        self.mock_conn.listStoragePools.return_value = ["test-vdb"]
+        self.mock_conn.storagePoolLookupByName.return_value.XMLDesc.return_value = """
+            <pool type="disk">
+              <name>test-vdb</name>
+              <source>
+                <device path='/dev/vdb'/>
+              </source>
+              <target>
+                <path>/dev</path>
+              </target>
+            </pool>
+        """
+
+        # No existing disk case
+        self.mock_conn.storagePoolLookupByName.return_value.listVolumes.return_value = (
+            []
+        )
+        diskp = virt._disk_profile(
+            self.mock_conn,
+            None,
+            "kvm",
+            [{"name": "mydisk", "pool": "test-vdb"}],
+            "hello",
+        )
+        self.assertEqual(diskp[0]["filename"], ("vdb1"))
+
+        # Append to the end case
+        self.mock_conn.storagePoolLookupByName.return_value.listVolumes.return_value = [
+            "vdb1",
+            "vdb2",
+        ]
+        diskp = virt._disk_profile(
+            self.mock_conn,
+            None,
+            "kvm",
+            [{"name": "mydisk", "pool": "test-vdb"}],
+            "hello",
+        )
+        self.assertEqual(diskp[0]["filename"], ("vdb3"))
+
+        # Hole in the middle case
+        self.mock_conn.storagePoolLookupByName.return_value.listVolumes.return_value = [
+            "vdb1",
+            "vdb3",
+        ]
+        diskp = virt._disk_profile(
+            self.mock_conn,
+            None,
+            "kvm",
+            [{"name": "mydisk", "pool": "test-vdb"}],
+            "hello",
+        )
+        self.assertEqual(diskp[0]["filename"], ("vdb2"))
+
+        # Reuse existing volume case
+        diskp = virt._disk_profile(
+            self.mock_conn,
+            None,
+            "kvm",
+            [{"name": "mydisk", "pool": "test-vdb", "source_file": "vdb1"}],
+            "hello",
+        )
+        self.assertEqual(diskp[0]["filename"], ("vdb1"))
+
+    def test_gen_xml_volume(self):
+        """
+        Test virt._gen_xml(), generating a disk of volume type
+        """
+        self.mock_conn.listStoragePools.return_value = ["default"]
+        self.mock_conn.storagePoolLookupByName.return_value.XMLDesc.return_value = (
+            "<pool type='dir'/>"
+        )
+        self.mock_conn.storagePoolLookupByName.return_value.listVolumes.return_value = [
+            "myvolume"
+        ]
+        diskp = virt._disk_profile(
+            self.mock_conn,
+            None,
+            "kvm",
+            [
+                {"name": "system", "pool": "default"},
+                {"name": "data", "pool": "default", "source_file": "myvolume"},
+            ],
+            "hello",
+        )
+        self.mock_conn.storagePoolLookupByName.return_value.XMLDesc.return_value = (
+            "<pool type='dir'/>"
+        )
+        nicp = virt._nic_profile(None, "kvm")
+        xml_data = virt._gen_xml(
+            self.mock_conn, "hello", 1, 512, diskp, nicp, "kvm", "hvm", "x86_64",
+        )
+        root = ET.fromstring(xml_data)
+        disk = root.findall(".//disk")[0]
+        self.assertEqual(disk.attrib["device"], "disk")
+        self.assertEqual(disk.attrib["type"], "volume")
+        source = disk.find("source")
+        self.assertEqual("default", source.attrib["pool"])
+        self.assertEqual("hello_system", source.attrib["volume"])
+        self.assertEqual("myvolume", root.find(".//disk[2]/source").get("volume"))
+
+        # RBD volume usage auth test case
+        self.mock_conn.listStoragePools.return_value = ["test-rbd"]
+        self.mock_conn.storagePoolLookupByName.return_value.XMLDesc.return_value = """
+            <pool type='rbd'>
+              <name>test-rbd</name>
+              <uuid>ede33e0a-9df0-479f-8afd-55085a01b244</uuid>
+              <capacity unit='bytes'>526133493760</capacity>
+              <allocation unit='bytes'>589928</allocation>
+              <available unit='bytes'>515081306112</available>
+              <source>
+                <host name='ses2.tf.local'/>
+                <host name='ses3.tf.local' port='1234'/>
+                <name>libvirt-pool</name>
+                <auth type='ceph' username='libvirt'>
+                  <secret usage='pool_test-rbd'/>
+                </auth>
+              </source>
+            </pool>
+        """
+        self.mock_conn.getStoragePoolCapabilities.return_value = """
+            <storagepoolCapabilities>
+              <pool type='rbd' supported='yes'>
+                <volOptions>
+                  <defaultFormat type='raw'/>
+                  <enum name='targetFormatType'>
+                  </enum>
+                </volOptions>
+              </pool>
+            </storagepoolCapabilities>
+        """
+        diskp = virt._disk_profile(
+            self.mock_conn,
+            None,
+            "kvm",
+            [{"name": "system", "pool": "test-rbd"}],
+            "test-vm",
+        )
+        xml_data = virt._gen_xml(
+            self.mock_conn, "hello", 1, 512, diskp, nicp, "kvm", "hvm", "x86_64",
+        )
+        root = ET.fromstring(xml_data)
+        disk = root.findall(".//disk")[0]
+        self.assertDictEqual(
             {
-                'name': 'mydisk',
-                'source_file': '/path/to/my/image.qcow2'
-            }], 'hello')
-
-        self.assertEqual(len(diskp), 1)
-        self.assertEqual(diskp[0]['source_file'], ('/path/to/my/image.qcow2'))
-
-    @patch('salt.modules.virt.pool_info', return_value={})
-    def test_disk_profile_kvm_disk_pool_notfound(self, mock_poolinfo):
-        '''
-        Test virt._gen_xml(), KVM case with pools defined.
-        '''
-        disks = {
-            'noeffect': [
-                {'first': {'size': 8192, 'pool': 'default'}},
-            ]
-        }
-        with patch.dict(virt.__salt__, {'config.get': MagicMock(side_effect=[  # pylint: disable=no-member
-                disks, "/default/path/"])}):
-            with self.assertRaises(CommandExecutionError):
-                virt._disk_profile('noeffect', 'kvm', [], 'hello')
-
-    @patch('salt.modules.virt.pool_info', return_value={'target_path': '/dev/disk/by-path'})
-    def test_disk_profile_kvm_disk_pool_invalid(self, mock_poolinfo):
-        '''
-        Test virt._gen_xml(), KVM case with pools defined.
-        '''
-        disks = {
-            'noeffect': [
-                {'first': {'size': 8192, 'pool': 'default'}},
-            ]
-        }
-        with patch.dict(virt.__salt__, {'config.get': MagicMock(side_effect=[  # pylint: disable=no-member
-                disks, "/default/path/"])}):
-            with self.assertRaises(CommandExecutionError):
-                virt._disk_profile('noeffect', 'kvm', [], 'hello')
+                "type": "network",
+                "device": "disk",
+                "source": {
+                    "protocol": "rbd",
+                    "name": "libvirt-pool/test-vm_system",
+                    "host": [
+                        {"name": "ses2.tf.local"},
+                        {"name": "ses3.tf.local", "port": "1234"},
+                    ],
+                    "auth": {
+                        "username": "libvirt",
+                        "secret": {"type": "ceph", "usage": "pool_test-rbd"},
+                    },
+                },
+                "target": {"dev": "vda", "bus": "virtio"},
+                "driver": {
+                    "name": "qemu",
+                    "type": "raw",
+                    "cache": "none",
+                    "io": "native",
+                },
+            },
+            salt.utils.xmlutil.to_dict(disk, True),
+        )
+
+        # RBD volume UUID auth test case
+        self.mock_conn.storagePoolLookupByName.return_value.XMLDesc.return_value = """
+            <pool type='rbd'>
+              <name>test-rbd</name>
+              <uuid>ede33e0a-9df0-479f-8afd-55085a01b244</uuid>
+              <capacity unit='bytes'>526133493760</capacity>
+              <allocation unit='bytes'>589928</allocation>
+              <available unit='bytes'>515081306112</available>
+              <source>
+                <host name='ses2.tf.local'/>
+                <host name='ses3.tf.local' port='1234'/>
+                <name>libvirt-pool</name>
+                <auth type='ceph' username='libvirt'>
+                  <secret uuid='some-uuid'/>
+                </auth>
+              </source>
+            </pool>
+        """
+        self.mock_conn.secretLookupByUUIDString.return_value.usageID.return_value = (
+            "pool_test-rbd"
+        )
+        diskp = virt._disk_profile(
+            self.mock_conn,
+            None,
+            "kvm",
+            [{"name": "system", "pool": "test-rbd"}],
+            "test-vm",
+        )
+        xml_data = virt._gen_xml(
+            self.mock_conn, "hello", 1, 512, diskp, nicp, "kvm", "hvm", "x86_64",
+        )
+        root = ET.fromstring(xml_data)
+        self.assertDictEqual(
+            {
+                "username": "libvirt",
+                "secret": {"type": "ceph", "usage": "pool_test-rbd"},
+            },
+            salt.utils.xmlutil.to_dict(root.find(".//disk/source/auth"), True),
+        )
+        self.mock_conn.secretLookupByUUIDString.assert_called_once_with("some-uuid")
+
+        # Disk volume test case
+        self.mock_conn.getStoragePoolCapabilities.return_value = """
+            <storagepoolCapabilities>
+              <pool type='disk' supported='yes'>
+                <volOptions>
+                  <defaultFormat type='none'/>
+                  <enum name='targetFormatType'>
+                    <value>none</value>
+                    <value>linux</value>
+                    <value>fat16</value>
+                  </enum>
+                </volOptions>
+              </pool>
+            </storagepoolCapabilities>
+        """
+        self.mock_conn.storagePoolLookupByName.return_value.XMLDesc.return_value = """
+            <pool type='disk'>
+              <name>test-vdb</name>
+              <source>
+                <device path='/dev/vdb'/>
+                <format type='gpt'/>
+              </source>
+            </pool>
+        """
+        self.mock_conn.listStoragePools.return_value = ["test-vdb"]
+        self.mock_conn.storagePoolLookupByName.return_value.listVolumes.return_value = [
+            "vdb1",
+        ]
+        diskp = virt._disk_profile(
+            self.mock_conn,
+            None,
+            "kvm",
+            [{"name": "system", "pool": "test-vdb"}],
+            "test-vm",
+        )
+        xml_data = virt._gen_xml(
+            self.mock_conn, "hello", 1, 512, diskp, nicp, "kvm", "hvm", "x86_64",
+        )
+        root = ET.fromstring(xml_data)
+        disk = root.findall(".//disk")[0]
+        self.assertEqual(disk.attrib["type"], "volume")
+        source = disk.find("source")
+        self.assertEqual("test-vdb", source.attrib["pool"])
+        self.assertEqual("vdb2", source.attrib["volume"])
+        self.assertEqual("raw", disk.find("driver").get("type"))
 
     def test_gen_xml_cdrom(self):
-        '''
+        """
         Test virt._gen_xml(), generating a cdrom device (different disk type, no source)
-        '''
-        diskp = virt._disk_profile(None, 'kvm', [{
-            'name': 'tested',
-            'device': 'cdrom',
-            'source_file': None,
-            'model': 'ide'}], 'hello')
-        nicp = virt._nic_profile(None, 'kvm')
+        """
+        self.mock_conn.storagePoolLookupByName.return_value.XMLDesc.return_value = (
+            "<pool type='dir'/>"
+        )
+        diskp = virt._disk_profile(
+            self.mock_conn,
+            None,
+            "kvm",
+            [
+                {"name": "system", "pool": "default"},
+                {
+                    "name": "tested",
+                    "device": "cdrom",
+                    "source_file": None,
+                    "model": "ide",
+                },
+                {
+                    "name": "remote",
+                    "device": "cdrom",
+                    "source_file": "http://myhost:8080/url/to/image?query=foo&filter=bar",
+                    "model": "ide",
+                },
+            ],
+            "hello",
+        )
+        nicp = virt._nic_profile(None, "kvm")
         xml_data = virt._gen_xml(
-            'hello',
-            1,
-            512,
-            diskp,
-            nicp,
-            'kvm',
-            'hvm',
-            'x86_64',
-            )
+            self.mock_conn, "hello", 1, 512, diskp, nicp, "kvm", "hvm", "x86_64",
+        )
         root = ET.fromstring(xml_data)
-        disk = root.findall('.//disk')[0]
-        self.assertEqual(disk.attrib['device'], 'cdrom')
-        self.assertIsNone(disk.find('source'))
+        disk = root.findall(".//disk")[1]
+        self.assertEqual(disk.get("type"), "file")
+        self.assertEqual(disk.attrib["device"], "cdrom")
+        self.assertIsNone(disk.find("source"))
+        self.assertEqual(disk.find("target").get("dev"), "hda")
+
+        disk = root.findall(".//disk")[2]
+        self.assertEqual(disk.get("type"), "network")
+        self.assertEqual(disk.attrib["device"], "cdrom")
+        self.assertEqual(
+            {
+                "protocol": "http",
+                "name": "/url/to/image",
+                "query": "query=foo&filter=bar",
+                "host": {"name": "myhost", "port": "8080"},
+            },
+            salt.utils.xmlutil.to_dict(disk.find("source"), True),
+        )
 
     def test_controller_for_esxi(self):
-        '''
+        """
         Test virt._gen_xml() generated device controller for ESXi/vmware
-        '''
-        diskp = virt._disk_profile('default', 'vmware', [], 'hello')
-        nicp = virt._nic_profile('default', 'vmware')
+        """
+        diskp = virt._disk_profile(self.mock_conn, "default", "vmware", [], "hello")
+        nicp = virt._nic_profile("default", "vmware")
         xml_data = virt._gen_xml(
-            'hello',
-            1,
-            512,
-            diskp,
-            nicp,
-            'vmware',
-            'hvm',
-            'x86_64',
-            )
+            self.mock_conn, "hello", 1, 512, diskp, nicp, "vmware", "hvm", "x86_64",
+        )
         root = ET.fromstring(xml_data)
-        controllers = root.findall('.//devices/controller')
+        controllers = root.findall(".//devices/controller")
         self.assertTrue(len(controllers) == 1)
         controller = controllers[0]
-        self.assertEqual(controller.attrib['model'], 'lsilogic')
+        self.assertEqual(controller.attrib["model"], "lsilogic")
 
     def test_controller_for_kvm(self):
-        '''
+        """
         Test virt._gen_xml() generated device controller for KVM
-        '''
-        diskp = virt._disk_profile('default', 'kvm', [], 'hello')
-        nicp = virt._nic_profile('default', 'kvm')
+        """
+        diskp = virt._disk_profile(self.mock_conn, "default", "kvm", [], "hello")
+        nicp = virt._nic_profile("default", "kvm")
         xml_data = virt._gen_xml(
-            'hello',
-            1,
-            512,
-            diskp,
-            nicp,
-            'kvm',
-            'hvm',
-            'x86_64',
-            )
+            self.mock_conn, "hello", 1, 512, diskp, nicp, "kvm", "hvm", "x86_64",
+        )
         root = ET.fromstring(xml_data)
-        controllers = root.findall('.//devices/controller')
+        controllers = root.findall(".//devices/controller")
         # There should be no controller
         self.assertTrue(len(controllers) == 0)
-        # kvm mac address shoud start with 52:54:00
-        self.assertTrue("mac address='52:54:00" in xml_data)
 
     def test_diff_disks(self):
-        '''
+        """
         Test virt._diff_disks()
-        '''
-        old_disks = ET.fromstring('''
+        """
+        old_disks = ET.fromstring(
+            """
             <devices>
               <disk type='file' device='disk'>
                 <source file='/path/to/img0.qcow2'/>
